-- Mikroelecktronika ADC Click services

-- Copyright (C)2017-2023, Philip Munts dba Munts Technologies.
--
-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions are met:
--
-- * Redistributions of source code must retain the above copyright notice,
--   this list of conditions and the following disclaimer.
--
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-- AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-- LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-- CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-- SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-- INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-- CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-- ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-- POSSIBILITY OF SUCH DAMAGE.

WITH MCP3204;
WITH SPI;
WITH Voltage;

PACKAGE ClickBoard.ADC IS

  -- SPI transfer characteristics

  SPI_Mode      : Natural RENAMES MCP3204.SPI_Mode;
  SPI_WordSize  : Natural RENAMES MCP3204.SPI_WordSize;
  SPI_Frequency : Natural RENAMES MCP3204.SPI_Frequency;

  -- Define an array of MCP3204 analog voltage inputs

  TYPE Inputs IS ARRAY (MCP3204.Channel) OF Voltage.Input;

  -- Create an array of MCP3204 analog voltage inputs

  FUNCTION Create
   (dev       : NOT NULL SPI.Device;
    reference : Voltage.Volts := 3.3) RETURN Inputs;

END ClickBoard.ADC;
